package net.theender.ldbridge;

import net.luckperms.api.LuckPerms;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.plugin.java.JavaPlugin;
import org.json.JSONArray;
import org.json.JSONObject;

import java.util.concurrent.ExecutionException;


public class LiizziisDiscordBridge extends JavaPlugin {
    String Instance;
    LuckPerms luckperms;
    FileConfiguration config = getConfig();
    JSONObject AllowedMentions = new JSONObject();

    Boolean DiscordLinking;
    Boolean MusicalSpawns;

    @Override
    public void onEnable() {
        this.AllowedMentions.put("parse", new JSONArray());
        getLogger().info("We're loading!");
        this.setupConfig();
        DiscordLinking = this.config.getBoolean("discord_linking");
        MusicalSpawns = this.config.getBoolean("musical_spawn_enable");
        getLogger().info(String.format("Discord linking: %s | Musical Spawn: %s", DiscordLinking, MusicalSpawns));
        getServer().getPluginManager().registerEvents(new LDListener(this), this);
        this.luckperms = getServer().getServicesManager().load(LuckPerms.class);
        if (luckperms == null) {
            throw new IllegalStateException("LuckPerms API not loaded. Is it installed?");
        }

        if (DiscordLinking) {
            CommandLink cmdLink = new CommandLink(this);
            this.getCommand("ldb").setExecutor(cmdLink);
            this.getCommand("ldb").setTabCompleter(cmdLink.onTabComplete);

            CommandLDBAdmin cmdAdmin = new CommandLDBAdmin();
            this.getCommand("ldb-admin").setExecutor(cmdAdmin);
            this.getCommand("ldb-admin").setTabCompleter(cmdAdmin.onTabComplete);
        }
        this.Instance = getConfig().getString("instance-name", "NOTSET");
        JSONObject Data = new JSONObject();
        Data.put("content", String.format("Liizzii's Discord/Guilded Bridge! **%s** reporting in", this.Instance));
        Bukkit.getScheduler().runTaskAsynchronously(this, () -> {
            try {
                utils.makePostRequest(this.getConfig().getString("join-part-hook"), Data);
            } catch (InterruptedException|ExecutionException e) {
                e.printStackTrace();
            }
        });
    }

    @Override
    public void onDisable() {
        getLogger().info("Oh shit!");
        this.saveConfig();
    }

    public void setupConfig() {
        this.config.addDefault("kick-no-discord", false);
        this.config.addDefault("discord_guild", (long) 0);
        this.config.addDefault("discord_roles.__example", (long) 1234565);
        this.config.addDefault("discord_linking", (boolean) false);
        this.config.addDefault("musical_spawn_radius", (long) 0);
        this.config.addDefault("musical_spawn_enable", (boolean) false);
        this.config.options().copyDefaults(true);
        saveConfig();
    }

}
